Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc_oce.F90	(revision 2715)
@@ -4,37 +4,31 @@
    !! Ocean trends :   set tracer and momentum trend variables
    !!======================================================================
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/TRD/trdmld_oce.F90,v 1.2 2005/03/27 18:35:23 opalod Exp $ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-#if defined key_top
+#if defined key_top   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-
-   USE par_oce                        ! ocean parameters
-   USE par_trc                        ! passive tracers parameters
+   USE par_oce       ! ocean parameters
+   USE par_trc       ! passive tracers parameters
 
    IMPLICIT NONE
    PUBLIC
 
-   !!* Namelist namtoptrd:  diagnostics on passive tracers trends
-   INTEGER  ::    nn_trd_trc                 !: time step frequency dynamics and tracers trends
-   INTEGER  ::    nn_ctls_trc                !: control surface type for trends vertical integration
+   !                                         !!* Namelist namtoptrd:  diagnostics on passive tracers trends
+   INTEGER  ::    nn_trd_trc                  !: time step frequency dynamics and tracers trends
+   INTEGER  ::    nn_ctls_trc                 !: control surface type for trends vertical integration
    REAL(wp) ::    rn_ucf_trc                  !: unit conversion factor (for netCDF trends outputs)
-   LOGICAL  ::    ln_trdmld_trc_instant    !: flag to diagnose inst./mean ML trc trends
-   LOGICAL  ::    ln_trdmld_trc_restart    !: flag to restart mixed-layer trc diagnostics
-   CHARACTER(len=50) ::  cn_trdrst_trc_in  !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=50) ::  cn_trdrst_trc_out !: suffix of pass. tracer restart name (output)
-   LOGICAL, DIMENSION (jptra) ::   ln_trdtrc  !: large trends diagnostic to write or not (namelist)
+   LOGICAL  ::    ln_trdmld_trc_instant       !: flag to diagnose inst./mean ML trc trends
+   LOGICAL  ::    ln_trdmld_trc_restart       !: flag to restart mixed-layer trc diagnostics
+   CHARACTER(len=50) ::  cn_trdrst_trc_in     !: suffix of pass. tracer restart name (input)
+   CHARACTER(len=50) ::  cn_trdrst_trc_out    !: suffix of pass. tracer restart name (output)
+   LOGICAL, DIMENSION(jptra) ::   ln_trdtrc   !: large trends diagnostic to write or not (namelist)
 
 # if defined key_trdtrc && defined key_iomput
    LOGICAL, PARAMETER ::   lk_trdtrc = .TRUE. 
-#else
+# else
    LOGICAL, PARAMETER ::   lk_trdtrc = .FALSE.   !: ML trend flag
-#endif
+# endif
 
-#if defined key_trdmld_trc
+# if defined key_trdmld_trc   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_trdmld_trc'                     mixed layer trends diagnostics
@@ -60,7 +54,7 @@
    !! Trends diagnostics parameters
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::            &
-      jpltrd_trc = 12,                  & !: number of mixed-layer trends arrays
-      jpktrd_trc = jpk                    !: max level for mixed-layer trends diag.
+   INTEGER, PARAMETER :: jpltrd_trc = 12    !: number of mixed-layer trends arrays
+      
+   INTEGER            :: jpktrd_trc         !: max level for mixed-layer trends diag.
 
    !! Arrays used for diagnosing mixed-layer trends 
@@ -68,15 +62,15 @@
    CHARACTER(LEN=80) :: clname_trc, ctrd_trc(jpltrd_trc+1,2)
 
-   INTEGER, DIMENSION(jpi,jpj) ::   &
+   INTEGER, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   &
       nmld_trc       , &                            !: mixed layer depth indexes 
       nbol_trc                                   !: mixed-layer depth indexes when read from file
 
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::  wkx_trc  !:
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  wkx_trc  !:
 
-   REAL(wp), DIMENSION(jpi,jpj) ::  rmld_trc     !: ML depth (m) corresponding to nmld_trc
-   REAL(wp), DIMENSION(jpi,jpj) ::  rmld_sum_trc !: needed to compute the leap-frog time mean of ML depth
-   REAL(wp), DIMENSION(jpi,jpj) ::  rmldbn_trc   !: idem
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  rmld_trc     !: ML depth (m) corresponding to nmld_trc
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  rmld_sum_trc !: needed to compute the leap-frog time mean of ML depth
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  rmldbn_trc   !: idem
 
-   REAL(wp), DIMENSION(jpi,jpj,jptra) ::  &
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  &
       tml_trc    ,                        &      !: \ "now" mixed layer temperature/salinity
       tmlb_trc   ,                        &      !: /  and associated "before" fields
@@ -89,5 +83,5 @@
                                                  !:     previous analysis period
                                                  
-   REAL(wp), DIMENSION(jpi,jpj,jptra) ::  &      
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  &      
       tmlatfb_trc, tmlatfn_trc ,          &      !: "before" Asselin contrib. at beginning of the averaging
                                                  !:     period (i.e. last contrib. from previous such period)
@@ -98,5 +92,5 @@
       tmlradm_trc                                !: accumulator for the previous trcrad trend
 
-   REAL(wp), DIMENSION(jpi,jpj,jpltrd_trc,jptra) ::  &
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  &
       tmltrd_trc,                         &      !: \ physical contributions to the total trend (for T/S),
                                                  !: / cumulated over the current analysis window
@@ -105,14 +99,14 @@
       tmltrd_csum_ub_trc                         !: before (prev. analysis period) cumulated sum over the
                                                  !: upper triangle
-   REAL(wp), DIMENSION(jpi,jpj,jptra) ::  &
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  &
       tmltrdm_trc                                !: total cumulative trends over the analysis window
 
-#else
+# else
    LOGICAL, PARAMETER ::   lk_trdmld_trc = .FALSE.   !: ML trend flag
-#endif
+# endif
 
-#if defined key_lobster
+# if defined key_lobster
    CHARACTER(LEN=80) :: clname_bio, ctrd_bio(jpdiabio,2)
-   REAL(wp), DIMENSION(jpi,jpj,jpdiabio) ::  &
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  &
       tmltrd_bio,                         &      !: \ biological contributions to the total trend ,
                                                  !: / cumulated over the current analysis window
@@ -122,4 +116,58 @@
                                                  !: upper triangle
 #endif
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/TRD/trdmld_oce.F90,v 1.2 2005/03/27 18:35:23 opalod Exp $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   INTEGER FUNCTION trd_mod_trc_oce_alloc()
+      !!----------------------------------------------------------------------
+      !!         *** ROUTINE trd_mod_trc_oce_alloc ***
+      !!----------------------------------------------------------------------
+      USE lib_mpp, ONLY: ctl_warn
+      INTEGER :: ierr(2)
+      !!----------------------------------------------------------------------
+      ierr(:) = 0
+      !
+# if defined key_trdmld_trc
+      ALLOCATE(nmld_trc(jpi,jpj),          nbol_trc(jpi,jpj),           &
+               wkx_trc(jpi,jpj,jpk),       rmld_trc(jpi,jpj),           &
+               rmld_sum_trc(jpi,jpj),      rmldbn_trc(jpi,jpj),         &
+               tml_trc(jpi,jpj,jptra),     tmlb_trc(jpi,jpj,jptra),     &
+               tmlbb_trc(jpi,jpj,jptra),   tmlbn_trc(jpi,jpj,jptra),    &
+               tml_sum_trc(jpi,jpj,jptra), tml_sumb_trc(jpi,jpj,jptra), &
+               tmltrd_atf_sumb_trc(jpi,jpj,jptra),                      &
+               tmltrd_rad_sumb_trc(jpi,jpj,jptra),                      &
+               !
+               tmlatfb_trc(jpi,jpj,jptra), tmlatfn_trc(jpi,jpj,jptra),  &
+               tmlatfm_trc(jpi,jpj,jptra), tmlradb_trc(jpi,jpj,jptra),  &
+               tmlradn_trc(jpi,jpj,jptra), tmlradm_trc(jpi,jpj,jptra),  &
+               !
+               tmltrd_trc(jpi,jpj,jpltrd_trc,jptra)         , &
+               tmltrd_sum_trc(jpi,jpj,jpltrd_trc,jptra)     , &
+               tmltrd_csum_ln_trc(jpi,jpj,jpltrd_trc,jptra) , &
+               tmltrd_csum_ub_trc(jpi,jpj,jpltrd_trc,jptra) , &
+               !
+               tmltrdm_trc(jpi,jpj,jptra)                   , STAT=ierr(1) )
+#endif
+      !
+# if defined key_lobster
+      ALLOCATE( tmltrd_bio        (jpi,jpj,jpdiabio) ,     &
+         &      tmltrd_sum_bio    (jpi,jpj,jpdiabio) ,     &
+         &      tmltrd_csum_ln_bio(jpi,jpj,jpdiabio) ,     &
+         &      tmltrd_csum_ub_bio(jpi,jpj,jpdiabio) , STAT=ierr(2) )
+# endif
+      !
+      trd_mod_trc_oce_alloc = MAXVAL(ierr)
+      !
+      IF( trd_mod_trc_oce_alloc /= 0 )   CALL ctl_warn('trd_mod_trc_oce_alloc: failed to allocate arrays')
+      !
+# if defined key_trdmld_trc
+      jpktrd_trc = jpk      ! Initialise what used to be a parameter - max level for mixed-layer trends diag.
+# endif
+      !
+   END FUNCTION trd_mod_trc_oce_alloc
 
 #else
@@ -129,4 +177,4 @@
 #endif
 
-
+   !!======================================================================
 END MODULE trdmod_trc_oce
Index: trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2715)
@@ -33,5 +33,14 @@
    !* IO manager *
    USE in_out_manager    
-                          
+ 
+   !* MPP library                         
+   USE lib_mpp 
+
+   !* Fortran utilities                         
+   USE lib_fortran
+
+   !* Lateral boundary conditions                         
+   USE lbclnk
+
    !* physical constants *
    USE phycst            
@@ -88,4 +97,5 @@
    USE dom_oce , ONLY :   e1t        =>   e1t        !: horizontal scale factors at t-point (m)  
    USE dom_oce , ONLY :   e2t        =>   e2t        !: horizontal scale factors at t-point (m)   
+   USE dom_oce , ONLY :   e1e2t      =>   e1e2t      !: cell surface at t-point (m2)
    USE dom_oce , ONLY :   e1u        =>   e1u        !: horizontal scale factors at u-point (m)
    USE dom_oce , ONLY :   e2u        =>   e2u        !: horizontal scale factors at u-point (m)
@@ -194,5 +204,4 @@
 
 #endif
-   USE lib_mpp , ONLY :   lk_mpp    =>  lk_mpp        !: Mpp flag
 
    USE dom_oce , ONLY :   nn_cla    =>  nn_cla        !: flag (0/1) for cross land advection 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2715)
@@ -17,6 +17,4 @@
    USE par_trc          ! TOP parameters
    USE oce_trc          ! ocean space and time domain variables
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! distributed memory computing
 
    IMPLICIT NONE
@@ -69,11 +67,13 @@
       INTEGER                              , INTENT(in), OPTIONAL ::   kdim      ! k- direction for 4D arrays
       !!
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: zmask, ztab3d 
       INTEGER  ::   overlap, jn, js, sind, eind, kdir, j_id
       REAL(wp) ::   zsum, zvctl
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask, ztab3d
       CHARACTER (len=20), DIMENSION(jptra) ::   cl
       CHARACTER (len=10) ::   cl2
       !!----------------------------------------------------------------------
 
+      ALLOCATE( zmask (jpi,jpj,jpk) )
+      ALLOCATE( ztab3d(jpi,jpj,jpk) )
       !                                      ! Arrays, scalars initialization 
       overlap       = 0
@@ -150,4 +150,7 @@
          !
       END DO
+      !
+      DEALLOCATE( zmask  )
+      DEALLOCATE( ztab3d )
       !
    END SUBROUTINE prt_ctl_trc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2715)
@@ -19,4 +19,6 @@
    PUBLIC
 
+   PUBLIC   trc_alloc   ! called by nemogcm.F90
+
    !! passive tracers names and units (read in namelist)
    !! --------------------------------------------------
@@ -34,50 +36,48 @@
    !! passive tracers fields (before,now,after)
    !! --------------------------------------------------
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) :: cvol   !: volume correction -degrad option- 
    REAL(wp), PUBLIC ::   trai                          !: initial total tracer
    REAL(wp), PUBLIC ::   areatot                       !: total volume 
-
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trn   !: traceur concentration for actual time step
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   tra   !: traceur concentration for next time step
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trb   !: traceur concentration for before time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:)   ::   cvol   !: volume correction -degrad option- 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   trn    !: traceur concentration for now time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   tra    !: traceur concentration for next time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:,:) ::   trb    !: traceur concentration for before time step
 
    !! interpolated gradient
    !!--------------------------------------------------  
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtru   !: horizontal gradient at u-points at bottom ocean level
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtrv   !: horizontal gradient at v-points at bottom ocean level
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::   gtru   !: hor. gradient at u-points at bottom ocean level
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION (:,:,:) ::   gtrv   !: hor. gradient at v-points at bottom ocean level
    
    !! passive tracers restart (input and output)
    !! ------------------------------------------  
-   LOGICAL , PUBLIC          ::  ln_rsttr      !: boolean term for restart i/o for passive tracers (namelist)
-   LOGICAL , PUBLIC          ::  lrst_trc      !: logical to control the trc restart write
-   INTEGER , PUBLIC          ::  nn_dttrc      !: frequency of step on passive tracers
-   INTEGER , PUBLIC          ::  nutwrs        !: output FILE for passive tracers restart
-   INTEGER , PUBLIC          ::  nutrst        !: logical unit for restart FILE for passive tracers
-   INTEGER , PUBLIC          ::  nn_rsttr      !: control of the time step ( 0 or 1 ) for pass. tr.
-   CHARACTER(len=50), PUBLIC ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=50), PUBLIC ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
+   LOGICAL          , PUBLIC ::  ln_rsttr        !: boolean term for restart i/o for passive tracers (namelist)
+   LOGICAL          , PUBLIC ::  lrst_trc        !: logical to control the trc restart write
+   INTEGER          , PUBLIC ::  nn_dttrc        !: frequency of step on passive tracers
+   INTEGER          , PUBLIC ::  nutwrs          !: output FILE for passive tracers restart
+   INTEGER          , PUBLIC ::  nutrst          !: logical unit for restart FILE for passive tracers
+   INTEGER          , PUBLIC ::  nn_rsttr        !: control of the time step ( 0 or 1 ) for pass. tr.
+   CHARACTER(len=50), PUBLIC ::  cn_trcrst_in    !: suffix of pass. tracer restart name (input)
+   CHARACTER(len=50), PUBLIC ::  cn_trcrst_out   !: suffix of pass. tracer restart name (output)
    
    !! information for outputs
    !! --------------------------------------------------
    INTEGER , PUBLIC ::   nn_writetrc   !: time step frequency for concentration outputs (namelist)
-   REAL(wp), PUBLIC, DIMENSION(jpk) ::   rdttrc        !: vertical profile of passive tracer time step
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   rdttrc        !: vertical profile of passive tracer time step
    
 # if defined key_diatrc && ! defined key_iomput
    !! additional 2D/3D outputs namelist
    !! --------------------------------------------------
-   INTEGER , PUBLIC                               ::   nn_writedia   !: frequency of additional arrays outputs(namelist)
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2d      !: 2d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2u      !: 2d output field unit   
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3d      !: 3d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3u      !: 3d output field unit
-   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2l      !: 2d output field long name
-   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3l      !: 3d output field long name
+   INTEGER         , PUBLIC                      ::   nn_writedia   !: frequency of additional arrays outputs(namelist)
+   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2d      !: 2d output field name
+   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2u      !: 2d output field unit   
+   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3d      !: 3d output field name
+   CHARACTER(len= 8), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3u      !: 3d output field unit
+   CHARACTER(len=80), PUBLIC, DIMENSION(jpdia2d) ::   ctrc2l      !: 2d output field long name
+   CHARACTER(len=80), PUBLIC, DIMENSION(jpdia3d) ::   ctrc3l      !: 3d output field long name
 
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,    jpdia2d) ::   trc2d    !:  additional 2d outputs  
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jpdia3d) ::   trc3d    !:  additional 3d outputs  
-   
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,  :) ::   trc2d    !:  additional 2d outputs  
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trc3d    !:  additional 3d outputs  
 # endif
 
-#if defined key_diabio || defined key_trdmld_trc
+# if defined key_diabio || defined key_trdmld_trc
    !                                                              !!*  namtop_XXX namelist *
    INTEGER , PUBLIC                               ::   nn_writebio   !: time step frequency for biological outputs 
@@ -85,9 +85,9 @@
    CHARACTER(len=20), PUBLIC, DIMENSION(jpdiabio) ::   ctrbiu      !: biological trends unit   
    CHARACTER(len=80), PUBLIC, DIMENSION(jpdiabio) ::   ctrbil      !: biological trends long name
-#endif
+# endif
 # if defined key_diabio
    !! Biological trends
    !! -----------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk,jpdiabio) :: trbio   !: biological trends
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trbio   !: biological trends
 # endif
 
@@ -99,4 +99,35 @@
 # endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3.1 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   INTEGER FUNCTION trc_alloc()
+      !!-------------------------------------------------------------------
+      !!                    *** ROUTINE trc_alloc ***
+      !!-------------------------------------------------------------------
+      USE lib_mpp, ONLY: ctl_warn
+      !!-------------------------------------------------------------------
+      !
+      ALLOCATE( cvol(jpi,jpj,jpk      ) ,                           &
+         &      trn (jpi,jpj,jpk,jptra) ,                           &
+         &      tra (jpi,jpj,jpk,jptra) ,                           &
+         &      trb (jpi,jpj,jpk,jptra) ,                           &
+         &      gtru(jpi,jpj    ,jptra) , gtrv(jpi,jpj,jptra) ,     &
+# if defined key_diatrc && ! defined key_iomput
+         &      trc2d(jpi,jpj,jpdia2d), trc3d(jpi,jpj,jpk,jpdia3d), &
+# endif
+# if defined key_diabio
+         &      trbio(jpi,jpj,jpk,jpdiabio),                        &
+#endif
+               rdttrc(jpk) ,  STAT=trc_alloc )      
+
+      IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
+      !
+   END FUNCTION trc_alloc
+
 #else
    !!----------------------------------------------------------------------
@@ -105,8 +136,4 @@
 #endif
 
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 2715)
@@ -25,6 +25,4 @@
    USE par_trc
    USE dianam    ! build name of file (routine)
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp
    USE ioipsl
 
@@ -32,5 +30,6 @@
    PRIVATE
 
-   PUBLIC   trc_dia   ! called by XXX module 
+   PUBLIC   trc_dia        ! called by XXX module 
+   PUBLIC   trc_dia_alloc  ! called by nemogcm.F90
 
    INTEGER  ::   nit5      !: id for tracer output file
@@ -40,6 +39,6 @@
    INTEGER  ::   ndimt51   !: number of ocean points in index array
    REAL(wp) ::   zjulian   !: ????   not DOCTOR !
-   INTEGER , DIMENSION (jpij*jpk) ::   ndext50   !: integer arrays for ocean 3D index
-   INTEGER , DIMENSION (jpij)     ::   ndext51   !: integer arrays for ocean surface index
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION (:) ::   ndext50   !: integer arrays for ocean 3D index
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION (:) ::   ndext51   !: integer arrays for ocean surface index
 # if defined key_diatrc
    INTEGER  ::   nitd      !: id for additional array output file
@@ -58,5 +57,5 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -68,6 +67,7 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
-      INTEGER, INTENT( in ) :: kt
-      INTEGER               :: kindic
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step
+      !
+      INTEGER ::   kindic   ! local integer
       !!---------------------------------------------------------------------
       !
@@ -95,7 +95,7 @@
       !!        IF kindic >0, output of fields before the time step loop
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step
-      INTEGER, INTENT( in ) ::   kindic      ! indicator of abnormal termination
-      !!
+      INTEGER, INTENT(in) ::   kt       ! ocean time-step
+      INTEGER, INTENT(in) ::   kindic   ! indicator of abnormal termination
+      !
       INTEGER ::   jn
       LOGICAL ::   ll_print = .FALSE.
@@ -183,7 +183,7 @@
          DO jn = 1, jptra
             IF( lutsav(jn) ) THEN
-               cltra  = ctrcnm(jn)   ! short title for tracer
-               cltral = ctrcnl(jn)   ! long title for tracer
-               cltrau = ctrcun(jn)   ! UNIT for tracer
+               cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
+               cltral = TRIM( ctrcnl(jn) )   ! long title for tracer
+               cltrau = TRIM( ctrcun(jn) )   ! UNIT for tracer
                CALL histdef( nit5, cltra, cltral, cltrau, jpi, jpj, nhorit5,  &
                   &          ipk, 1, ipk,  ndepit5, 32, clop, zsto, zout ) 
@@ -208,5 +208,5 @@
 
       DO jn = 1, jptra
-         cltra = ctrcnm(jn)      ! short title for tracer
+         cltra  = TRIM( ctrcnm(jn) )   ! short title for tracer
          IF( lutsav(jn) ) CALL histwrite( nit5, cltra, it, trn(:,:,:,jn), ndimt50, ndext50 )
       END DO
@@ -216,5 +216,4 @@
       IF( kt == nitend .OR. kindic < 0 )   CALL histclo( nit5 )
       !
-
    END SUBROUTINE trcdit_wr
 
@@ -237,6 +236,6 @@
       !!        IF kindic >0, output of fields before the time step loop
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step
-      INTEGER, INTENT( in ) ::   kindic      ! indicator of abnormal termination
+      INTEGER, INTENT(in) ::   kt       ! ocean time-step
+      INTEGER, INTENT(in) ::   kindic   ! indicator of abnormal termination
       !!
       LOGICAL ::   ll_print = .FALSE.
@@ -308,7 +307,7 @@
          ! more 3D horizontal arrays
          DO jl = 1, jpdia3d
-            cltra  = ctrc3d(jl)   ! short title for 3D diagnostic
-            cltral = ctrc3l(jl)   ! long title for 3D diagnostic
-            cltrau = ctrc3u(jl)   ! UNIT for 3D diagnostic
+            cltra  = TRIM( ctrc3d(jl) )   ! short title for 3D diagnostic
+            cltral = TRIM( ctrc3l(jl) )  ! long title for 3D diagnostic
+            cltrau = TRIM( ctrc3u(jl) )  ! UNIT for 3D diagnostic
             CALL histdef( nitd, cltra, cltral, cltrau, jpi, jpj, nhoritd,   &
                &          ipk, 1, ipk,  ndepitd, 32, clop, zsto, zout )
@@ -317,7 +316,7 @@
          ! more 2D horizontal arrays
          DO jl = 1, jpdia2d
-            cltra  = ctrc2d(jl)    ! short title for 2D diagnostic
-            cltral = ctrc2l(jl)   ! long title for 2D diagnostic
-            cltrau = ctrc2u(jl)   ! UNIT for 2D diagnostic
+            cltra  = TRIM( ctrc2d(jl) )   ! short title for 2D diagnostic
+            cltral = TRIM( ctrc2l(jl) )  ! long title for 2D diagnostic
+            cltrau = TRIM( ctrc2u(jl) )  ! UNIT for 2D diagnostic
             CALL histdef( nitd, cltra, cltral, cltrau, jpi, jpj, nhoritd,  &
                &          1, 1, 1,  -99, 32, clop, zsto, zout )
@@ -345,5 +344,5 @@
       ! more 3D horizontal arrays
       DO jl = 1, jpdia3d
-         cltra = ctrc3d(jl)   ! short title for 3D diagnostic
+         cltra  = TRIM( ctrc3d(jl) )   ! short title for 3D diagnostic
          CALL histwrite( nitd, cltra, it, trc3d(:,:,:,jl), ndimt50 ,ndext50)
       END DO
@@ -351,5 +350,5 @@
       ! more 2D horizontal arrays
       DO jl = 1, jpdia2d
-         cltra = ctrc2d(jl)   ! short title for 2D diagnostic
+         cltra  = TRIM( ctrc2d(jl) )   ! short title for 2D diagnostic
          CALL histwrite(nitd, cltra, it, trc2d(:,:,jl), ndimt51  ,ndext51)
       END DO
@@ -364,5 +363,5 @@
 # else
    SUBROUTINE trcdii_wr( kt, kindic )                      ! Dummy routine
-      INTEGER, INTENT ( in ) :: kt, kindic
+      INTEGER, INTENT (in) :: kt, kindic
    END SUBROUTINE trcdii_wr
 # endif
@@ -400,5 +399,4 @@
       ! Initialisation
       ! --------------
-
       
       ! local variable for debugging
@@ -451,7 +449,7 @@
          ! biological trends
          DO jl = 1, jpdiabio
-            cltra  = ctrbio(jl)   ! short title for biological diagnostic
-            cltral = ctrbil(jl)   ! long title for biological diagnostic
-            cltrau = ctrbiu(jl)   ! UNIT for biological diagnostic
+            cltra  = TRIM( ctrbio(jl) )   ! short title for biological diagnostic
+            cltral = TRIM( ctrbil(jl) )  ! long title for biological diagnostic
+            cltrau = TRIM( ctrbiu(jl) )  ! UNIT for biological diagnostic
             CALL histdef( nitb, cltra, cltral, cltrau, jpi, jpj, nhoritb,  &
                &         ipk, 1, ipk,  ndepitb, 32, clop, zsto, zout)
@@ -477,5 +475,5 @@
 
       DO jl = 1, jpdiabio
-         cltra = ctrbio(jl)  ! short title for biological diagnostic
+         cltra  = TRIM( ctrbio(jl) )   ! short title for biological diagnostic
          CALL histwrite(nitb, cltra, it, trbio(:,:,:,jl), ndimt50,ndext50)
       END DO
@@ -485,5 +483,4 @@
       IF( kt == nitend .OR. kindic < 0 )   CALL histclo( nitb )
       !
-
    END SUBROUTINE trcdib_wr
 
@@ -496,4 +493,13 @@
 # endif 
 
+   INTEGER FUNCTION trc_dia_alloc()
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_dia_alloc  ***
+      !!---------------------------------------------------------------------
+      ALLOCATE( ndext50(jpij*jpk), ndext51(jpij), STAT=trc_dia_alloc )
+      !
+      IF( trc_dia_alloc /= 0 )   CALL ctl_warn('trc_dia_alloc : failed to allocate arrays')
+      !
+   END FUNCTION trc_dia_alloc
 #else
    !!----------------------------------------------------------------------
